
--MOD VG_PGA 17 --
--MOD Version: 0.08 FS2017--
--MOD Author:  Vanguard --
--MOD date: 23/12/2016 --
--Copyright © 2016 Vanguard --

VG_PDA = {};
VG_PDA.moddir = g_currentModDirectory;
VG_PDA.modName = g_currentModName;
if VG_PDA.moddir:sub(-1) ~= '/' then
	VG_PDA.moddir = VG_PDA.moddir .. '/';
end;

-- forward dec'l
VG_PDA.screens = {};

--[[2.0
if #InputBinding.actions[InputBinding.TOGGLE_PDA].keys1 == 1 and 
   InputBinding.actions[InputBinding.TOGGLE_PDA].keys1[1] == InputBinding.actions[InputBinding.VG_PDA_TOGGLE_PDA].keys1[1] then
  table.insert(InputBinding.actions[InputBinding.TOGGLE_PDA].keys1, 1,  Input.KEY_lshift);
  InputBinding.preprocessInputActions();
end;
]]

-----------self.foliageStateOverlay = createFoliageStateOverlay("foliageState", 256, 256)
-----------resetFoliageStateOverlay(self.foliageStateOverlay)
--[[
orig_setTextBold = setTextBold;
function setTextBold()
  orig_setTextBold(true);
end;
]]

function VG_PDA:init(width)
  self.overlayPosX = 0.003;
  self.overlayPosY = 0.005;
  self.overlayWidth = width or 1/3;
  self.overlayHeight = self.overlayWidth * 0.5 * g_screenAspectRatio;
  self.Overlay = Overlay:new("VG_PDA_frame", Utils.getFilename('VG_PDA.png', VG_PDA.moddir), self.overlayPosX, self.overlayPosY, self.overlayWidth, self.overlayHeight);

  self.pixelWidth = self.overlayWidth / 1024.0;
  self.pixelHeight = self.pixelWidth * g_screenAspectRatio;
  
  self.screenOffsetX = self.overlayPosX + (92 * self.pixelWidth); -- 92
  self.screenOffsetY = self.overlayPosY + (46 * self.pixelHeight); --46
  self.leftX = self.screenOffsetX + (22 * self.pixelWidth);
  self.screenWidth = 840 * self.pixelWidth; -- 840
  self.screenHeight = 372 * self.pixelHeight; -- 420 - 48
  self.lineSpacing = (372 / 12) * self.pixelHeight;
  self.screenFont = self.lineSpacing * 0.85;
  self.titleFontSize = 48 * .80 * self.pixelHeight;
  self.titlePosY = self.screenOffsetY + self.screenHeight + (48 * .20 * self.pixelHeight);
  self.screenCols = {}
  self.colWidth = (self.screenWidth - (44 * self.pixelWidth)) / 4
  self.screenCols[1] = self.leftX;
  self.screenCols[2] = self.leftX + self.colWidth; 
  self.screenCols[3] = self.leftX + self.colWidth * 2;
  self.screenCols[4] = self.leftX + self.colWidth * 3;
end;

function VG_PDA:loadMap(name)
  self.doOnce = false;
  self.showPDA=false;
  self.showFrame = true;
  self.currentScreen = 1;
end;

function VG_PDA:deleteMap()
  -- Cleanup
  if self.Overlay ~= nil then
    self.Overlay:delete();
  end;
end;

function VG_PDA:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VG_PDA:keyEvent(unicode, sym, modifier, isDown)
end;

function VG_PDA:hide()
  self.screens[self.currentScreen].target:deactivate();
  self.showPDA = false;
  g_currentMission.ingameMap:setVisible(true);
end;

function VG_PDA:show()
  self.showPDA = true;
  g_currentMission.ingameMap:setVisible(false);
  self.screens[self.currentScreen].target:activate();
end;

function VG_PDA:changeScreen(index)
  self.screens[self.currentScreen].target:deactivate();
  self.currentScreen = index;
  if self.currentScreen > #self.screens then
    self.currentScreen = 1;
  elseif self.currentScreen < 1 then
    self.currentScreen = #self.screens;
  end;
  self.screens[self.currentScreen].target:activate();
end;

function VG_PDA:update()
  if not self.doOnce then
    self.doOnce = true;
  end;
  
  if self.showPDA == true then
    if InputBinding.hasEvent(InputBinding.VG_PDA_TOGGLE_PDA) then
      self:hide();
    elseif InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_SCREEN) then
      self:changeScreen(self.currentScreen + 1);
    elseif InputBinding.hasEvent(InputBinding.VG_PDA_PREV_SCREEN) then
      self:changeScreen(self.currentScreen - 1);
    end;
  else -- showPDA == false
    if InputBinding.hasEvent(InputBinding.VG_PDA_TOGGLE_PDA) then
      self:show();
    end;
  end;
  for i=1, 10 do
    local binding = "VG_PDA_SCREEN_" .. i;
    if InputBinding.hasEvent(InputBinding[binding]) then
      if i > #self.screens then break; end;
      
      if self.showPDA == true then
        if self.currentScreen == i then
          self:hide();
        else
          self:changeScreen(i);
        end;
      else -- showPDA == false
          self.currentScreen = i;
          self:show();
      end;
    end;
  end;
  if self.showPDA == true then
    g_currentMission:addHelpButtonText(g_i18n:getText("PDAClose"), InputBinding.VG_PDA_TOGGLE_PDA);
    if #self.screens > 1 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDA_NEXT_SCREEN"), InputBinding.VG_PDA_NEXT_SCREEN);
      g_currentMission:addHelpButtonText(g_i18n:getText("PDA_PREV_SCREEN"), InputBinding.VG_PDA_PREV_SCREEN);
    end;
  end;
end;

function VG_PDA:draw()
  if self.showPDA == true then
    if self.currentScreen ~= #self.screens then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextScreen"), InputBinding.VG_PDA_TOGGLE_PDA);
    else
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAClose"), InputBinding.VG_PDA_TOGGLE_PDA);
    end;
    if self.showFrame then
      self.Overlay:render();
      setTextColor(1, 1, 1, 1);
      setTextAlignment(RenderText.ALIGN_LEFT);
      setTextBold(true);
      renderText(self.screenCols[1], self.titlePosY, self.titleFontSize, self.screens[self.currentScreen].title);
      setTextBold(false);
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(self.screenCols[4] + self.colWidth, self.titlePosY + self.lineSpacing * 0.15, self.screenFont, string.format("%.2d:%.2d", g_currentMission.environment.currentHour, g_currentMission.environment.currentMinute));
    end;
  end;
end;
VG_PDA:init();
addModEventListener(VG_PDA);

-- #######################
-- # VG_PDA_Screen
-- #######################
VG_PDA_Screen = {};
local VG_PDA_Screen_mt = Class(VG_PDA_Screen);

function VG_PDA_Screen:new(numColumns, numRows)
  local instance = {}; 
  
  instance.textAlignment = RenderText.ALIGN_LEFT;
  instance.numColumns = numColumns or 4;
  instance.numRows = numRows or 12;
  
  setmetatable(instance, VG_PDA_Screen_mt);
  
  return instance;
end;

function VG_PDA_Screen:registerScreen(title, index)
  if index ~= nil then
    table.insert(VG_PDA.screens, index, {title = title, target = self});
  else
    table.insert(VG_PDA.screens, {title = title, target = self});
  end;
end;
function VG_PDA_Screen:deregisterScreen(index)
  if index == nil then  
    for i=1, #VG_PDA.screens do
      if VG_PDA.screens[i].target == self then
        index = i;
        break;
      end;
    end;
  end;
  
  if index ~= nil then
    if VG_PDA.currentScreen == index then
      VG_PDA:changeScreen(index + 1);   
    end;
    table.remove(VG_PDA.screens, index);
    if (VG_PDA.currentScreen > index) then
      VG_PDA.currentScreen = VG_PDA.currentScreen - 1;
    end;
  end;
end;

function VG_PDA_Screen:getWidth()
  return VG_PDA.screenWidth;
end;
function VG_PDA_Screen:getHeight()
  return VG_PDA.screenHeight;
end;
function VG_PDA_Screen:getOffsetX()
  return VG_PDA.screenOffsetX;
end;
function VG_PDA_Screen:getOffsetY()
  return VG_PDA.screenOffsetY;
end;
function VG_PDA_Screen:getScreenFont()
  return self:getLineSpacing() * 0.85;
end;
function VG_PDA_Screen:getLineSpacing()
  return VG_PDA.screenHeight / self.numRows;
end;
function VG_PDA_Screen:getScreenCols()
  local screenCols = {};
  local colWidth = self:getColWidth();
  for x = 1, self.numColumns do
    screenCols[x] = VG_PDA.leftX + colWidth * (x-1);
  end;
  return screenCols;
end;
function VG_PDA_Screen:getNumColumns()
  return self.numColumns;
end;
function VG_PDA_Screen:getNumRows()
  return self.numRows;
end;
function VG_PDA_Screen:getColWidth()
  return (VG_PDA.screenWidth - (44 * VG_PDA.pixelWidth)) / self.numColumns;
end;
function VG_PDA_Screen:getMargin()
  return self:getLineSpacing() * 0.15;
end;
function VG_PDA_Screen:getTopY()
  return VG_PDA.screenOffsetY + VG_PDA.screenHeight;
end;
function VG_PDA_Screen:getLeftX()
  return VG_PDA.leftX;
end;

function VG_PDA_Screen:setTitle(title)
  for i, screen in ipairs(VG_PDA.screens) do
    if (screen.target == self) then
      screen.title = title;
      break;
    end;
  end;
end;

function VG_PDA_Screen:setTextAlignment(alignment)
  self.textAlignment = alignment;
end;

function VG_PDA_Screen:getTextAlignment(alignment)
  return self.textAlignment;
end;

function VG_PDA_Screen:renderText(col, row, str)
  local offset = 0;
  local colWidth = self:getColWidth();
  setTextAlignment(self.textAlignment);
  if (self.textAlignment == RenderText.ALIGN_RIGHT) then
    offset = colWidth;
  elseif (self.textAlignment == RenderText.ALIGN_CENTER) then
    offset = colWidth / 2;
  end;
  
  renderText(VG_PDA.leftX + colWidth * (col-1) + offset, self:getTopY() + self:getMargin() - self:getLineSpacing() * row, self:getScreenFont(), str);
end;
function VG_PDA_Screen:setTextColorRed()
  setTextColor(0.8069, 0.0097, 0.0097, 1);
end;
function VG_PDA_Screen:setTextColorGreen()
  setTextColor(0.2705, 0.6514, 0.0802, 1);
end;
function VG_PDA_Screen:setTextColorYellow()
  setTextColor(1, 0.5, 0, 1);
end;
function VG_PDA_Screen:setTextColorBlue()
  setTextColor(0.0742, 0.4341, 0.6939, 1);
end;
function VG_PDA_Screen:setTextColorBlack()
  setTextColor(0, 0, 0, 1);
end;
function VG_PDA_Screen:setTextColorWhite()
  setTextColor(1, 1, 1, 1);
end;
function VG_PDA_Screen:setTextColor(r,g,b,a)
  setTextColor(r,g,b,a);
end;

function VG_PDA_Screen:showFrame(show)
  if show == false then
    VG_PDA.showFrame = false;
  else
    VG_PDA.showFrame = true;
  end;
end;
  
function VG_PDA_Screen:loadMap()
end;
function VG_PDA_Screen:activate()
end;
function VG_PDA_Screen:deactivate()
end;
function VG_PDA_Screen:draw()
end;
function VG_PDA_Screen:deleteMap()
end;
function VG_PDA_Screen:mouseEvent()
end;
function VG_PDA_Screen:keyEvent()
end;
function VG_PDA_Screen:update()
end;
--setTextWrapWidth 
VG_PDA_Screen.textWrap = function (str, fontsize, width)
 local here = 1
 local numLines = 1;
 return str:gsub("(%s+)()(%S+)()",
  function (sp, st, word, fi)
    if utf8Strlen(str:sub(here, fi-1)) > getTextLineLength(fontsize, str:sub(here, fi-1) ,width) then
      here = st;
      numLines = numLines + 1;
      return "\n"..word;
    end;
  end ), numLines;
end;


-- #######################
-- # VG_PDA_mapScreen
-- #######################
local VG_PDA_mapScreen = VG_PDA_Screen:new();

VG_PDA_mapScreen.mapEvents = {
VG_PDA_MAP_DOWN_LEFT  = {x = -1, z =  1},
VG_PDA_MAP_DOWN       = {x =  0, z =  1},
VG_PDA_MAP_DOWN_RIGHT = {x =  1, z =  1},
VG_PDA_MAP_LEFT       = {x = -1, z =  0},
VG_PDA_MAP_RIGHT      = {x =  1, z =  0},
VG_PDA_MAP_UP_LEFT    = {x = -1, z = -1},
VG_PDA_MAP_UP         = {x =  0, z = -1},
VG_PDA_MAP_UP_RIGHT   = {x =  1, z = -1}
};

VG_PDA_mapScreen.panFactor = 0.0007;
VG_PDA_mapScreen.zoomFactor = 0.0007;
--[[
function VG_PDA_mapScreen:toggleSize(superFunc, ...)
  if VG_PDA_mapScreen.isActive then
     VG_PDA_mapScreen.fullScreen = not VG_PDA_mapScreen.fullScreen;
  else
    superFunc(self, ...);
  end;
end;
]]

function VG_PDA_mapScreen:loadMap()
  self.isActive = false;

  self.showState = 0;
  self.isDirty = true;
  self.timer = 0;
  self.fullScreen = false;
  self.centerXPos = 0.5;
  self.centerZPos = 0.5;
  self.isPanning = false;
  self.visWidth = 0.7;
  self.mapWidth, self.mapHeight = VG_PDA_Screen.getWidth(),
                                  VG_PDA_Screen.getHeight();
  --IngameMap.toggleSize = Utils.overwrittenFunction(IngameMap.toggleSize, VG_PDA_mapScreen.toggleSize);
end;

function VG_PDA_mapScreen:activate()
  self.isActive = true;

  self.fullScreen = false;

  if not g_inGameMenu.mapSelectorMapping then
    g_inGameMenu:setupMapOverview();
  end;
  
end;

function VG_PDA_mapScreen:deactivate()
  self.isActive = false;
  local ingameMap = g_currentMission.ingameMap;

  ingameMap:resetSettings();
  self:showFrame(true);
  
end;

function VG_PDA_mapScreen:generateFruitOverlay()
  local origState = g_inGameMenu.mapOverviewSelector.state;
  g_inGameMenu.mapOverviewSelector.state = self.showState;
  g_inGameMenu:generateFruitOverlay();
  g_inGameMenu.mapOverviewSelector.state = origState;
  self.timer = 0;
end;

function VG_PDA_mapScreen:update(dt)
  local ingameMap = g_currentMission.ingameMap;

  if g_gui:getIsGuiVisible() and g_gui.currentGuiName == "InGameMenu" then
    self.isDirty = true;
  end;
  if self.timer < 60000 then
    self.timer = self.timer + dt;
  else
    self.isDirty = true;
  end;
  
  if self.isActive and g_gui.currentGui == nil then
    
    g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextState"), InputBinding.VG_PDA_NEXT_PAGE);
    if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
      self.showState = self.showState + 1;
      if self.showState > 3 then self.showState = 0 end;
      if self.showState ~= 0 then self:generateFruitOverlay(); end;
    end;
    g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevState"), InputBinding.VG_PDA_PREV_PAGE);
    if InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
      self.showState = self.showState - 1;
      if self.showState < 0 then self.showState = 3 end;
      if self.showState ~= 0 then self:generateFruitOverlay(); end;
    end;
    if InputBinding.hasEvent(InputBinding.TOGGLE_MAP_SIZE) then
      self.fullScreen = not self.fullScreen;
      if self.fullScreen then
        self.mapWidth, self.mapHeight = ingameMap.maxMapWidth,
                                        ingameMap.maxMapHeight;
        self.alpha = 0.7;
      else
        self.mapWidth, self.mapHeight = VG_PDA_Screen.getWidth(),
                                        VG_PDA_Screen.getHeight();
        self.alpha = 1;
      end;
    end;
    if not self.fullScreen then
      for k,v in pairs(self.mapEvents) do
        if InputBinding[k] ~= nil then
          if InputBinding.isPressed(InputBinding[k]) then
            self.centerXPos = ingameMap.centerXPos + v.x * self.panFactor * self.visWidth * dt;
            self.centerZPos = ingameMap.centerZPos + v.z * self.panFactor * self.visWidth * dt;
            self.isPanning = true;
          end;
        end;
      end;
      if InputBinding.hasEvent(InputBinding.VG_PDA_MAP_CENTER) then
        self.isPanning = false;
      end;
      if InputBinding.isPressed(InputBinding.VG_PDA_MAP_ZOOM_IN) then
        ingameMap:zoom(-self.zoomFactor * dt);
        self.visWidth = ingameMap.mapVisWidthMin;
      end;
      if InputBinding.isPressed(InputBinding.VG_PDA_MAP_ZOOM_OUT) then
        ingameMap:zoom(self.zoomFactor * dt);
        self.visWidth = ingameMap.mapVisWidthMin;
      end;
    end;
    
    if self.isDirty then
      self.isDirty = false;
      self:generateFruitOverlay();
    end;
    
    if self.fullScreen then
      self:showFrame(false);
    else
      self:showFrame(true);
    end;

  end;
end;

function VG_PDA_mapScreen:draw()
  if self.isActive then

    local ingameMap = g_currentMission.ingameMap;
 
    ingameMap:zoom(0);
    IngameMap.iconZoom = ingameMap.maxIconZoom;
    
    ingameMap:updatePlayerPosition();
    
    ingameMap:setPosition(self.getOffsetX(), self.getOffsetY());

    ingameMap:setSize(self.mapWidth, self.mapHeight);
    
    if self.fullScreen then
      ingameMap.mapVisWidthMin = 1;
    else
      ingameMap.mapVisWidthMin = self.visWidth;
    end;

    if self.isPanning then
      ingameMap.centerXPos = self.centerXPos;
      ingameMap.centerZPos = self.centerZPos;
    else
      ingameMap.centerXPos = ingameMap.normalizedPlayerPosX;
      ingameMap.centerZPos = ingameMap.normalizedPlayerPosZ;
    end;

    local leftBorderReached, rightBorderReached, topBorderReached, bottomBorderReached = 
      ingameMap:drawMap(self.alpha)
      
    local foliageOverlay = g_inGameMenu.foliageStateOverlay;
  
    if self.showState ~= 0 and getIsFoliageStateOverlayReady(foliageOverlay) then
      setOverlayUVs(foliageOverlay, unpack(ingameMap.mapUVs));
      
      renderOverlay(foliageOverlay, 
        VG_PDA_Screen.getOffsetX(),
        VG_PDA_Screen.getOffsetY(),
        self.mapWidth,
        self.mapHeight);
    end;

    ingameMap:renderHotspots(leftBorderReached, rightBorderReached, topBorderReached, bottomBorderReached, false, self.fullScreen);
    ingameMap:renderPlayerArrows(false, leftBorderReached, rightBorderReached, topBorderReached, bottomBorderReached, true);
    ingameMap:renderHotspots(leftBorderReached, rightBorderReached, topBorderReached, bottomBorderReached, true, self.fullScreen);

    --[[
    if ingameMap.selectedHotspot ~= nil then
        ingameMap:renderHotspot(ingameMap.selectedHotspot, leftBorderReached, rightBorderReached, topBorderReached, bottomBorderReached, self.fullScreen);
    end;
    ]]
    
    ingameMap:renderPlayersCoordinates();
    ingameMap:drawLatencyToServer();
    ingameMap:drawInputBinding();
  end;
end;

VG_PDA_mapScreen:registerScreen(g_i18n:getText("ui_map"));
addModEventListener(VG_PDA_mapScreen);

-- #######################
-- # VG_PDA_weatherScreen
-- #######################

local VG_PDA_weatherScreen = VG_PDA_Screen:new();
VG_PDA_weatherScreen.rainTypes = {"cloudy", "fog", "hail", "rain"};
function VG_PDA_weatherScreen:loadMap()
  self.isActive = false;
  self.showDay = 1;
  self.showNews = 1;
  self.weatherOverlays = {};
  self.newsText = {};
  self.newsDirty = true;
  self.currentDay = 0;
  
  local environment = g_currentMission.environment;
  local screenCols = self:getScreenCols();
  local topY, lineSpacing, colWidth, screenFont, margin = 
    self:getTopY() + self:getMargin(), self:getLineSpacing(), self:getColWidth(), self:getScreenFont(), self:getMargin();
  self.weatherOverlays["cloudy"] = Overlay:new(
        "cloudy", 
        g_baseUIFilename,
        0,0,
        lineSpacing * 2 / g_screenAspectRatio, lineSpacing * 2);
        self.weatherOverlays["cloudy"]:setUVs({ 0.1484375, 0.1279296875, 0.1484375, 0.1904296875, 0.2109375, 0.1279296875, 0.2109375, 0.1904296875 })
        self.weatherOverlays["cloudy"]:setColor(1,1,1,1);
  self.weatherOverlays["fog"] = Overlay:new(
        "fog", 
        g_baseUIFilename, 
        0,0,
        lineSpacing * 2 / g_screenAspectRatio, lineSpacing * 2);
        self.weatherOverlays["fog"]:setUVs({ 0.078125, 0.1279296875, 0.078125, 0.1904296875, 0.140625, 0.1279296875, 0.140625, 0.1904296875 })
        self.weatherOverlays["fog"]:setColor(1,1,1,1);
  self.weatherOverlays["rain"] = Overlay:new(
        "rain", 
        g_baseUIFilename, 
        0,0,
        lineSpacing * 2 / g_screenAspectRatio, lineSpacing * 2);
        self.weatherOverlays["rain"]:setUVs({ 0.2197265625, 0.1279296875, 0.2197265625, 0.1904296875, 0.2822265625, 0.1279296875, 0.2822265625, 0.1904296875 })
        self.weatherOverlays["rain"]:setColor(1,1,1,1);
  self.weatherOverlays["hail"] = Overlay:new(
        "hail", 
        g_baseUIFilename, 
        0,0,
        lineSpacing * 2 / g_screenAspectRatio, lineSpacing * 2);
        self.weatherOverlays["hail"]:setUVs({ 0.2900390625, 0.1279296875, 0.2900390625, 0.1904296875, 0.3525390625, 0.1279296875, 0.3525390625, 0.1904296875 })
        self.weatherOverlays["hail"]:setColor(1,1,1,1);
  self.weatherOverlays["sun"] = Overlay:new(
        "sun", 
        g_baseUIFilename, 
        0,0,
        lineSpacing * 2 / g_screenAspectRatio, lineSpacing * 2);
        self.weatherOverlays["sun"]:setUVs({ 0.0078125, 0.1279296875, 0.0078125, 0.1904296875, 0.0703125, 0.1279296875, 0.0703125, 0.1904296875 })
        self.weatherOverlays["sun"]:setColor(1,1,1,1);
  
  self.overlay = Overlay:new("VG_PDA_weatherScreen", Utils.getFilename('VG_PDA_weather.png', VG_PDA.moddir), self:getOffsetX(), self:getOffsetY(), self:getWidth(), self:getHeight());
  
  environment:addDayChangeListener(self);
  environment:addHourChangeListener(self);
end;

function VG_PDA_weatherScreen:activate()
  local environment = g_currentMission.environment;
  self.isActive = true;
 
  self.currentDay = g_currentMission.environment.currentDay;
 
  if self.showNews > #self.newsText then
    self.showNews = 1;
  end;
end;

function VG_PDA_weatherScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_weatherScreen:dayChanged()
  if self.isActive then
    self.currentDay = g_currentMission.environment.currentDay;
  end;
end;

function VG_PDA_weatherScreen:hourChanged()
  self.newsDirty = true;
end;

function VG_PDA_weatherScreen:deleteMap()
  for _, overlay in pairs(self.weatherOverlays) do
    overlay:delete();
  end;
  self.weatherOverlays = nil;
  
  self.overlay:delete();
  self.overlay = nil;

  self.newsText = nil;
end;

function VG_PDA_weatherScreen:update()
  if self.isActive then
    
    if self.showDay == 1 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextDay"), InputBinding.VG_PDA_NEXT_PAGE);
      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showDay = 5;
      end;
    else
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevDay"), InputBinding.VG_PDA_PREV_PAGE);
      if InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showDay = 1;
      end;
    end;
    
    if self.newsDirty then
      local colWidth, screenFont = self:getColWidth(), self:getScreenFont();
      local brandSale = g_currentMission.economyManager.brandSale;
      local vehicleShopSales = g_currentMission.economyManager.vehicleShopSales;
      
      self.newsText = {};
      self.newsDirty = false;
      if brandSale and brandSale.isRunning then
        table.insert(self.newsText, 
          { title = string.format(g_i18n:getText("message_brandSaleStartTitle"), brandSale:getBrandName()),
            text = self.textWrap(string.format(g_i18n:getText("message_brandSaleStartText"), brandSale:getBrandName(), brandSale.saleDuration), screenFont, colWidth * 4)
          });
      end;
      for _, sale in pairs(vehicleShopSales) do
        if sale.isRunning then
          table.insert(self.newsText, 
          { title = string.format(g_i18n:getText("message_brandSaleStartTitle"), sale:getBrandName() .. " " .. StoreItemsUtil.storeItems[sale.storeItemIndex].name), 
            text = self.textWrap(string.format(g_i18n:getText("PDASaleTimeLeft"), sale.saleDuration), screenFont, colWidth * 4)
          });
        end;
      end;
      if self.showNews > #self.newsText then
        self.showNews = 1;
      end;
    end

    if #self.newsText > 1 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDACycleNews"), InputBinding.VG_PDA_MORE_INFO);
      if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
        self.showNews = self.showNews + 1;
        if self.showNews > #self.newsText then
          self.showNews = 1;
        end;
      end;
    end;
    
  end;
end;

function VG_PDA_weatherScreen:draw()
  if self.isActive then
    self.overlay:render();
    local screenCols = self:getScreenCols();
    local topY, lineSpacing, colWidth, screenFont, margin = 
      self:getTopY() + self:getMargin(), self:getLineSpacing(), self:getColWidth(), self:getScreenFont(), self:getMargin();
    local col = 0;
    local environment = g_currentMission.environment;
    local degrees = g_i18n:getText("unit_degreeCelsiusShort");
    local highs = environment.weatherTemperaturesDay;
    local lows = environment.weatherTemperaturesNight;
    for i=self.showDay, self.showDay + 3 do
      col = col + 1;
      local rainType = environment:getRainTypeIdAtDay(self.currentDay + i - 1) or "sun";
      self.weatherOverlays[rainType]:setPosition(screenCols[((i-1) % 4) + 1] + (colWidth - lineSpacing * 2 / g_screenAspectRatio) / 2, topY - lineSpacing * 3 - margin);
      self.weatherOverlays[rainType]:render();
      self:setTextColorWhite();
      self:setTextAlignment(RenderText.ALIGN_CENTER);
      local dayOfWeek = math.mod(self.currentDay + i - 2, 7) + 1;
      local dayName;
      if i == 1 then
        dayName = g_i18n:getText("ui_today");
      else
        dayName = g_i18n:getText("ui_financesDay" .. dayOfWeek);
      end;
      self:renderText(col, 1, dayName);
      self:setTextColorRed();
      self:renderText(col, 4, string.format("%d %s", highs[i], degrees));
      self:setTextColorBlue();
      self:renderText(col, 5, string.format("%d %s", lows[i], degrees));
    end;
    
    self:setTextColorWhite();
    --[[2.0
    if #g_currentMission.ingameNews == 0 then
      setTextAlignment(RenderText.ALIGN_CENTER);
      setTextBold(true);
      renderText(screenCols[3], topY - lineSpacing * 7, screenFont, g_i18n:getText("IngameNews_NoNewsTitle"));
      setTextBold(false);
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * 8, screenFont, g_i18n:getText("IngameNews_NoNewsText"));
    else
      local ingameNews = g_currentMission.ingameNews;
      setTextAlignment(RenderText.ALIGN_CENTER);
      setTextBold(true);
      renderText(screenCols[3], topY - lineSpacing * 7, screenFont, ingameNews[self.showNews].title);
      setTextBold(false);
      if #ingameNews > 1 then
        setTextAlignment(RenderText.ALIGN_RIGHT);
        renderText(screenCols[4] + colWidth - margin, topY - lineSpacing * 11, screenFont, "("..g_i18n:formatNumber(self.showNews).."/"..g_i18n:formatNumber(#ingameNews)..")");
      end;
      setTextAlignment(RenderText.ALIGN_LEFT);
      local text = self.textWrap(ingameNews[self.showNews].text, screenFont, screenCols[4] + colWidth - screenCols[1]);
      renderText(screenCols[1], topY - lineSpacing * 8, screenFont, text);
    end;
    ]]
    if #self.newsText == 0 then
    else
      self:setTextAlignment(RenderText.ALIGN_CENTER);
      setTextBold(true);
      renderText(screenCols[3], topY - lineSpacing * 7, screenFont, self.newsText[self.showNews].title);
      setTextBold(false);
      
      self:setTextAlignment(RenderText.ALIGN_LEFT);
      self:renderText(1, 8, self.newsText[self.showNews].text);
    end;
  end;
end;

VG_PDA_weatherScreen:registerScreen(g_i18n:getText("ui_weatherForecast") .. " / " .. g_i18n:getText("ui_ingameNews"));
addModEventListener(VG_PDA_weatherScreen);


-- #######################
-- # VG_PDA_storageScreen
-- #######################

local VG_PDA_storageScreen = VG_PDA_Screen:new(8,14);
function VG_PDA_storageScreen:loadMap()
  local i18n;
  if g_currentMission.missionInfo.customEnvironment ~= nil then
    i18n = _G[g_currentMission.missionInfo.customEnvironment].g_i18n;
  else
    i18n = g_i18n;
  end;
  
  self.fruitCols = 5;
  self.locationCols = 3;
  
  self.fruitsInStorage = {};
  self.fruitOverlays = {};
  self.sellLocations = {};
  
  self.isActive = false;
  self.showFruit = 1;
  self.showStation = 1;

  
  self.overlay = Overlay:new("VG_PDA_storageScreen", Utils.getFilename('VG_PDA_14gray.png', VG_PDA.moddir), self:getOffsetX(), self:getOffsetY(), self:getWidth(), self:getHeight());
  
end;

function VG_PDA_storageScreen:deleteMap()
  self.fruitsInStorage = nil;
  self.sellLocations = nil;
  
  for _, overlay in ipairs(self.fruitOverlays) do
    overlay:delete();
  end;
  
  self.overlay:delete();
  self.overlay = nil;
  
  self.fruitOverlays = nil;
end;

function VG_PDA_storageScreen:activate()
  self.isActive = true;
  
  if self.doOnce then return; end;
  self.doOnce = true;
  
  local i18n;
  if g_currentMission.missionInfo.customEnvironment ~= nil then
    i18n = _G[g_currentMission.missionInfo.customEnvironment].g_i18n;
  else
    i18n = g_i18n;
  end;
  
  local siloTriggers = {};
  for _, storage in pairs(g_currentMission.storages) do
    local tipTrigger, siloTrigger = next(storage.tipTriggers), next(storage.siloTriggers);
    if (tipTrigger and siloTrigger) then
      siloTriggers[tipTrigger.stationName] = siloTrigger;
    end;
  end;
  
  local acceptedFruits = {};
  for stationName, siloTrigger in pairs(siloTriggers) do
    local fillLevels, cap = siloTrigger:getAllFillLevels();
    for index, _ in pairs(fillLevels) do
      local fruit = FillUtil.fillTypeIndexToDesc[index];
      acceptedFruits[index] = fruit;
    end;
    
    local numLines = 1;
    local locationName = stationName;
    
    if i18n:hasText(stationName) then
      locationName = i18n:getText(stationName);
    end;
    
    if getTextLineLength(self:getScreenFont(), locationName, self:getColWidth() * self.locationCols - self:getMargin()) < utf8Strlen(locationName) then
      locationName, numLines = self.textWrap(locationName, self:getScreenFont(), self:getColWidth() * self.locationCols - self:getMargin());
    end;
    if siloTrigger == g_currentMission.farmSiloTrigger then
        table.insert(self.sellLocations, 1, {name = locationName, numLines = numLines, siloTrigger = siloTrigger});
    else
        table.insert(self.sellLocations, {name = locationName, numLines = numLines, siloTrigger = siloTrigger});
    end
  end;

  local screenCols = self:getScreenCols();
  local height = self:getLineSpacing() * 1.5;
  local width = height / g_screenAspectRatio;
  local i = 0;
  for _, fruit in pairs(acceptedFruits) do
    i = i + 1;
    table.insert(self.fruitsInStorage, fruit.index);
  
    table.insert(self.fruitOverlays, 
      Overlay:new(
        fruit.name, 
        fruit.hudOverlayFilenameSmall, 
        screenCols[((i-1) % self.fruitCols + self.locationCols + 1)] + self:getColWidth() / 2 - width / 2, self:getTopY() - height,
        width, height));
    self.fruitOverlays[i]:setColor(1, 1, 1, 1);
  end;
end;

function VG_PDA_storageScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_storageScreen:update()
  if self.isActive then
    if #self.sellLocations > self:getNumRows() - 3 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextStations"), InputBinding.VG_PDA_MORE_INFO);
      if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
        self.showStation = self.showStation + self:getNumRows() - 3;
        if self.showStation > #self.sellLocations then
          self.showStation = 1;
        end;
      end;
    end
    if #self.fruitsInStorage > self.fruitCols then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextFruits"), InputBinding.VG_PDA_NEXT_PAGE);
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevFruits"), InputBinding.VG_PDA_PREV_PAGE);
      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showFruit = self.showFruit + self.fruitCols;
        if self.showFruit > #self.fruitsInStorage then
          self.showFruit = 1;
        end;
      end;
      if InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showFruit = self.showFruit - self.fruitCols;
        if self.showFruit < 1 then
          self.showFruit = math.floor((#self.fruitsInStorage - 1) / self.fruitCols) * self.fruitCols + 1;
        end;
      end;
    end;
  end;
end;

function VG_PDA_storageScreen:draw()
  if not self.isActive then return end;
  self.overlay:render();  
  local screenCols = self:getScreenCols();
  local topY, lineSpacing, colWidth, screenFont = 
    self:getTopY() + self:getMargin(), self:getLineSpacing(), self:getColWidth(), self:getScreenFont();

  -- Fruit name row
  local column = self.locationCols;
  for i=self.showFruit, math.min(#self.fruitsInStorage, self.showFruit + self.fruitCols - 1) do
    column = column + 1;
    local fruitIndex = self.fruitsInStorage[i];
    self.fruitOverlays[i]:render();
  end;
  
  local fillLevelsTotal = {};
  local row = 2;
  for i=self.showStation, math.min(#self.sellLocations, self.showStation + self:getNumRows() - 3) do
    row = row + 1;
    
    setTextBold(true);
    self:setTextAlignment(RenderText.ALIGN_LEFT);
    self:setTextColorWhite();
    self:renderText(1, row, self.sellLocations[i].name);
    setTextBold(false);
    
    local fillLevels, capacity = self.sellLocations[i].siloTrigger:getAllFillLevels();
    column = self.locationCols;
    for j=self.showFruit, math.min(#self.fruitsInStorage, self.showFruit + self.fruitCols - 1) do
      column = column + 1;
      local fruitIndex = self.fruitsInStorage[j];
    
      if fillLevels[fruitIndex] ~= nil and fillLevels[fruitIndex] > 0 then
        self:setTextAlignment(RenderText.ALIGN_RIGHT);
        self:setTextColorWhite();
        self:renderText(column, row,
            g_i18n:formatNumber(fillLevels[fruitIndex]));
        fillLevelsTotal[fruitIndex] = Utils.getNoNil(fillLevelsTotal[fruitIndex], 0) + fillLevels[fruitIndex];
      end;
    end;
  end;
  if #self.sellLocations > 1 then
    row = row + 1;
    setTextBold(true);
    self:setTextAlignment(RenderText.ALIGN_LEFT);
    self:setTextColorWhite();
    self:renderText(1, row, g_i18n:getText("ui_total"));
    setTextBold(false);
    column = self.locationCols;
    for j=self.showFruit, math.min(#self.fruitsInStorage, self.showFruit + self.fruitCols - 1) do
      column = column + 1;
      local fruitIndex = self.fruitsInStorage[j];
      
      if fillLevelsTotal[fruitIndex] ~= nil and fillLevelsTotal[fruitIndex] > 0 then
        self:setTextAlignment(RenderText.ALIGN_RIGHT);
        self:setTextColorWhite();
        self:renderText(column, row,
            g_i18n:formatNumber(fillLevelsTotal[fruitIndex]));
      end;
    end;
  end;
end;

VG_PDA_storageScreen:registerScreen(g_i18n:getText("statistic_storage"));
addModEventListener(VG_PDA_storageScreen);


-- #######################
-- # VG_PDA_priceScreen
-- #######################
local VG_PDA_priceScreen = VG_PDA_Screen:new(8,14);
VG_PDA_priceScreen.PRICE_FALLING = 2;
VG_PDA_priceScreen.PRICE_CLIMBING = 4;
VG_PDA_priceScreen.PRICE_LOW = 8;
VG_PDA_priceScreen.PRICE_HIGH = 16;
VG_PDA_priceScreen.PRICE_GREAT_DEMAND = 48;
VG_PDA_priceScreen.COLOR_RED = {0.8069, 0.0097, 0.0097, 1};
VG_PDA_priceScreen.COLOR_GREEN = {0.2705, 0.6514, 0.0802, 1};
VG_PDA_priceScreen.COLOR_BLUE = {0.0742, 0.4341, 0.6939, 1};

function VG_PDA_priceScreen:loadMap()
  local i18n;
  if g_currentMission.missionInfo.customEnvironment ~= nil then
    i18n = _G[g_currentMission.missionInfo.customEnvironment].g_i18n;
  else
    i18n = g_i18n;
  end;
  
  self.locationCols = 3;
  self.fruitCols = 5;
  self.arrowHeight = self:getLineSpacing() / 2;
  self.arrowWidth = self.arrowHeight / g_screenAspectRatio;
  local fruitsInEconomySellable = {};
  self.fruitsInEconomy = {};
  self.fruitOverlays = {};
  self.sellLocations = {};
  
  self.isActive = false;
  self.showStation = 1;
  self.showFruit = 1;
  
  self.overlay = Overlay:new("VG_PDA_priceScreen", Utils.getFilename('VG_PDA_14gray.png', VG_PDA.moddir), self:getOffsetX(), self:getOffsetY(), self:getWidth(), self:getHeight());
  
  local locationExists = {};
  setTextBold(true);
  for _, location in pairs(g_currentMission.tipTriggers) do
    if (location.isSellingPoint) then
      -- add fruits here instead
      local hasFruitsInEconomy = false;
      for index, _ in pairs(location.acceptedFillTypes) do
        local fruit = FillUtil.fillTypeIndexToDesc[index];
        if fruit.showOnPriceTable then
          fruitsInEconomySellable[index] = fruit;
          hasFruitsInEconomy = true;
        end;
      end;

      local stationName = location.stationName;
      local sellLocation;
      if hasFruitsInEconomy then --TODO don't need anymore (17)
        if (locationExists[stationName] == nil) then   
          local numLines = 1;
          local locationName = stationName;
          
          if i18n:hasText(stationName) then
            locationName = i18n:getText(stationName);
          end;
          
          if getTextLineLength(self:getScreenFont(), locationName, self:getColWidth() * self.locationCols - self:getMargin()) < utf8Strlen(locationName) then
            locationName, numLines = self.textWrap(locationName, self:getScreenFont(), self:getColWidth() * self.locationCols - self:getMargin());
          end;
          
          sellLocation = {name = locationName, numLines = numLines, tipTriggers = {location}};
          table.insert(self.sellLocations, sellLocation);
          locationExists[stationName] = sellLocation;
        else
           table.insert(locationExists[stationName].tipTriggers, location);
        end;
      end;
    end;
  end;
  setTextBold(false);
    
  local screenCols = self:getScreenCols();
  local i = 0;
  local height = self:getLineSpacing() * 1.5;
  local width = height / g_screenAspectRatio;
  for index, fruit in pairs(fruitsInEconomySellable) do
    i = i + 1;
    table.insert(self.fruitsInEconomy, index);
    table.insert(self.fruitOverlays, 
      Overlay:new(
        fruit.name, 
        fruit.hudOverlayFilenameSmall, 
        screenCols[((i-1) % self.fruitCols + self.locationCols + 1)] + self:getColWidth() / 2 - width / 2, self:getTopY() - height,
        width, height));
    self.fruitOverlays[i]:setColor(1, 1, 1, 1);
  end;
  
  table.sort(self.sellLocations, function (a,b) return a.name:gsub("\n?(.*)","%1") < b.name:gsub("\n?(.*)","%1") end);
  
  self.arrowOverlay = Overlay:new(
    "priceArrow",
    g_baseUIFilename,
    0,0,
    self.arrowWidth, self.arrowHeight);
  local arrowLeftX = 418/1024;
  local arrowRightX = (418+16)/1024;
  local arrowBottomY = (1024-790-16)/1024;
  local arrowTopY = (1024-790) / 1024;
  self.arrowOverlay:setUVs({arrowLeftX, arrowBottomY, arrowLeftX, arrowTopY, arrowRightX, arrowBottomY, arrowRightX, arrowTopY})

end;

function VG_PDA_priceScreen:activate()
  self.isActive = true;
end;

function VG_PDA_priceScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_priceScreen:update()
  if self.isActive then
    if #self.sellLocations > self:getNumRows() - 2 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextStations"), InputBinding.VG_PDA_MORE_INFO);
      if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
        self.showStation = self.showStation + self:getNumRows() - 2;
        if self.showStation > #self.sellLocations then
          self.showStation = 1;
        end;
      end;
    end;
    if #self.fruitsInEconomy > self.fruitCols then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextFruits"), InputBinding.VG_PDA_NEXT_PAGE);
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevFruits"), InputBinding.VG_PDA_PREV_PAGE);
      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showFruit = self.showFruit + self.fruitCols;
        if self.showFruit > #self.fruitsInEconomy then
          self.showFruit = 1;
        end;
      end;
      if InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showFruit = self.showFruit - self.fruitCols;
        if self.showFruit < 1 then
          self.showFruit = math.floor((#self.fruitsInEconomy - 1) / self.fruitCols) * self.fruitCols + 1;
        end;
      end;
    end;
  end;
end;

function VG_PDA_priceScreen:draw()
  if not self.isActive then return end;
  
  self.overlay:render();
  self:setTextColorWhite();
  local screenCols = self:getScreenCols();
  local topY, lineSpacing, colWidth, screenFont = 
    self:getTopY() + self:getMargin(), self:getLineSpacing(), self:getColWidth(), self:getScreenFont();

  -- Fruit name row
  local column = self.locationCols;
  for i=self.showFruit, math.min(#self.fruitsInEconomy, self.showFruit + self.fruitCols - 1) do
    column = column + 1;
    local fruitIndex = self.fruitsInEconomy[i];
    self.fruitOverlays[i]:render();
  end;

  local row = 2;
  for i=self.showStation, math.min(#self.sellLocations, self.showStation + self:getNumRows() - 2) do
    row = row + 1;

    setTextBold(true);
    self:setTextAlignment(RenderText.ALIGN_LEFT);
    self:setTextColorWhite();
    self:renderText(1, row, self.sellLocations[i].name);
    setTextBold(false);
    for _,tipTrigger in ipairs(self.sellLocations[i].tipTriggers) do
      column = self.locationCols;
      for j=self.showFruit, math.min(#self.fruitsInEconomy, self.showFruit + self.fruitCols - 1) do
        column = column + 1;
        local fruitIndex = self.fruitsInEconomy[j];

        if tipTrigger.acceptedFillTypes[fruitIndex] ~= nil then
          local trend = tipTrigger.fillTypePriceInfo[fruitIndex];
          self:setTextColorWhite();
          if trend == self.PRICE_FALLING then
            self.arrowOverlay:setPosition(screenCols[column] + colWidth - self.arrowWidth, topY - lineSpacing * row);
            self.arrowOverlay:setColor(unpack(self.COLOR_RED));
            self.arrowOverlay:setRotation(math.rad(-90), self.arrowWidth / 2, self.arrowHeight / 2);
            self.arrowOverlay:render();
          elseif trend == self.PRICE_CLIMBING then
            self.arrowOverlay:setPosition(screenCols[column] + colWidth - self.arrowWidth, topY - lineSpacing * row);
            self.arrowOverlay:setColor(unpack(self.COLOR_GREEN));
            self.arrowOverlay:setRotation(math.rad(90), self.arrowWidth / 2, self.arrowHeight / 2);
            self.arrowOverlay:render();        
          elseif trend == self.PRICE_LOW then
            self:setTextColorRed();
          elseif trend == self.PRICE_HIGH then
            self:setTextColorGreen();
          elseif trend == self.PRICE_GREAT_DEMAND then
            self:setTextColor(unpack(self.COLOR_BLUE));
          end;
          
          self:setTextAlignment(RenderText.ALIGN_RIGHT);
          self:renderText(column, row,
              g_i18n:formatMoney(math.floor(tipTrigger:getEffectiveFillTypePrice(fruitIndex) * 1000)) .. "   ");
        end;
      end;
    end;
  end;
end;

function VG_PDA_priceScreen:deleteMap()

  self.sellLocations = nil;
  self.fruitsInEconomy = nil;

  for _, overlay in ipairs(self.fruitOverlays) do
    overlay:delete();
  end;
  self.fruitOverlays = nil;

  self.arrowOverlay:delete();
  self.arrowOverlays = nil;
  
  self.overlay:delete();
  self.overlay = nil;
  -- g_currentMission.environment:removeHourChangeListener(self);
end;

VG_PDA_priceScreen:registerScreen(g_i18n:getText("ui_ingameMenuPrices"));
addModEventListener(VG_PDA_priceScreen);


-- #######################
-- # VG_PDA_financeScreen
-- #######################
local VG_PDA_financeScreen = VG_PDA_Screen:new(2, 14);
function VG_PDA_financeScreen:loadMap()
  self.isActive = false;
  self.showStat = 1;
  
  self.overlay = Overlay:new("VG_PDA_financeScreen", Utils.getFilename('VG_PDA_finance.png', VG_PDA.moddir), self:getOffsetX(), self:getOffsetY(), self:getWidth(), self:getHeight());
end;

function VG_PDA_financeScreen:deleteMap()
  self.overlay:delete();
  self.overlay = nil;
end;

function VG_PDA_financeScreen:activate()
  self.isActive = true;
  self.showDay = 1;
  self:setTitle(g_i18n:getText("ui_finances") .. " - " .. g_i18n:getText("ui_today"));
end;

function VG_PDA_financeScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_financeScreen:update()
  if self.isActive then
    local numDays = math.min(#g_currentMission.missionStats.financeStatsHistory + 1, 7);
    if self.showDay < numDays then
        g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextDay"), InputBinding.VG_PDA_NEXT_PAGE);
    end;
    if self.showDay > 1 then
        g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevDay"), InputBinding.VG_PDA_PREV_PAGE);
    end;
    if (InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) and self.showDay < numDays) or 
       (InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) and self.showDay > 1) then
      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showDay = self.showDay + 1;
        if self.showDay > numDays then
          self.showDay = numDays;
        end;
      elseif InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showDay = self.showDay - 1;
        if self.showDay < 1 then
          self.showDay = 1;
        end;
      end;
      self.dayOfWeek = math.mod(g_currentMission.environment.currentDay - self.showDay, 7) + 1;
      if self.showDay == 1 then
        self:setTitle(g_i18n:getText("ui_finances") .. " - " .. g_i18n:getText("ui_today"));
      else
        self:setTitle(g_i18n:getText("ui_finances") .. " - " .. g_i18n:getText("ui_financesDay" .. self.dayOfWeek));
      end;
    end;
    local financeStats = g_currentMission.missionStats.financeStats;
    if #financeStats.statNames > self:getNumRows() - 2 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowMoreFinances"), InputBinding.VG_PDA_MORE_INFO);
      if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
        self.showStat = self.showStat + self:getNumRows() - 2;
        if self.showStat > #financeStats.statNames then
          self.showStat = 1;
        end;
      end;
    end;
  end;
end;

function VG_PDA_financeScreen:draw()
  if self.isActive then
    self.overlay:render();

    local financeStats = g_currentMission.missionStats.financeStats;
    local financeStatsHistory = g_currentMission.missionStats.financeStatsHistory;
    local total = 0;
    local statNames = financeStats.statNames;
    local row = 0;
    for i=1, #financeStats.statNames do
      if self.showDay == 1 then
        amount = financeStats[financeStats.statNames[i]];
      else
        amount = financeStatsHistory[#financeStatsHistory - self.showDay + 2][financeStats.statNames[i]];
      end;
      total = total + amount;
    end;
    for i=self.showStat, math.min(#financeStats.statNames, self.showStat + self:getNumRows() - 3) do
      row = row + 1;
      self:setTextColorWhite();
      self:setTextAlignment(RenderText.ALIGN_LEFT);
      setTextBold(true);
      self:renderText(1, row, financeStats.statNamesI18n[statNames[i]]);
      setTextBold(false);
      self:setTextAlignment(RenderText.ALIGN_RIGHT);
      local amount;
      if self.showDay == 1 then
        amount = financeStats[financeStats.statNames[i]];
      else
        amount = financeStatsHistory[#financeStatsHistory - self.showDay + 2][financeStats.statNames[i]];
      end;

      if  amount < 0 then
        self:setTextColorRed();
      end;
      self:renderText(2, row, g_i18n:formatMoney(amount));
    end;
    self:setTextColorWhite();
    self:setTextAlignment(RenderText.ALIGN_LEFT);
    setTextBold(true);
    self:renderText(1, self:getNumRows() - 1, g_i18n:getText("ui_total"));
    setTextBold(false);
    self:setTextAlignment(RenderText.ALIGN_RIGHT);
    if total < 0 then
      self:setTextColorRed();
    else
      self:setTextColorWhite();
    end;
    self:renderText(2, self:getNumRows() - 1, g_i18n:formatMoney(total));
    if self.showDay == 1 then
      self:setTextColorWhite();
      self:setTextAlignment(RenderText.ALIGN_LEFT);
      setTextBold(true);
      self:renderText(1, self:getNumRows(), g_i18n:getText("ui_balance"));
      self:setTextAlignment(RenderText.ALIGN_RIGHT);
      local balance = g_currentMission.missionStats.money;
      if balance < 0 then
        self:setTextColorRed();
      else
        self:setTextColorWhite();
      end;
      self:renderText(2, self:getNumRows(), g_i18n:formatMoney(balance));
      setTextBold(false);
    end;
  end;
end;

VG_PDA_financeScreen:registerScreen(g_i18n:getText("ui_finances") .. " - " .. g_i18n:getText("ui_today"));
addModEventListener(VG_PDA_financeScreen);


-- #######################
-- # VG_PDA_statsScreen
-- #######################
local VG_PDA_statsScreen = VG_PDA_Screen:new(4, 14);
function VG_PDA_statsScreen:loadMap()
  self.isActive = false;
  self.showPage = 1;
  
  self.overlay = Overlay:new("VG_PDA_statsScreen", Utils.getFilename('VG_PDA_14gray.png', VG_PDA.moddir), self:getOffsetX(), self:getOffsetY(), self:getWidth(), self:getHeight());
end;

function VG_PDA_statsScreen:delete()
  self.overlay:delete();
  self.overlay = nil;
end;

function VG_PDA_statsScreen:activate()
  self.isActive = true;
  self.statData = g_currentMission.missionStats:getStatisticData();
end;

function VG_PDA_statsScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_statsScreen:update()
  if self.isActive then
    g_currentMission:addHelpButtonText(g_i18n:getText("PDAMoreStats"), InputBinding.VG_PDA_MORE_INFO);
    if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
      self.showPage = self.showPage + self:getNumRows() - 1;
      if self.showPage > #g_currentMission.missionStats.statisticData then
        self.showPage = 1;
      end;
    end;
  end;
end;

function VG_PDA_statsScreen:draw()
  if not self.isActive then return; end;
  
  self.overlay:render();

  self:setTextColorWhite();
  self:setTextAlignment(RenderText.ALIGN_RIGHT);
  setTextBold(true);
  self:renderText(3, 1, g_i18n:getText("ui_session"));
  self:renderText(4, 1, g_i18n:getText("ui_total"));
  setTextBold(false);
  
  local currentLine = 2;
  for i=self.showPage, math.min(#self.statData, self.showPage + self:getNumRows() - 2) do
    self:setTextAlignment(RenderText.ALIGN_LEFT);
    setTextBold(true);
    self:renderText(1, currentLine, self.statData[i].name);
    setTextBold(false);
    self:setTextAlignment(RenderText.ALIGN_RIGHT);
    self:renderText(3, currentLine, self.statData[i].valueSession);
    self:renderText(4, currentLine, self.statData[i].valueTotal);
    currentLine = currentLine + 1;
  end;
end;

VG_PDA_statsScreen:registerScreen(g_i18n:getText("ui_statistics"));
addModEventListener(VG_PDA_statsScreen);


-- #######################
-- # Debug
-- #######################
if fileExists(VG_PDA.moddir .. 'debug.lua') then
  source(VG_PDA.moddir .. 'debug.lua')
end;